/*
 *
 *  $Id: init.c,v 1.1 2011/04/20 21:30:14 joel Exp $
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "pmacros.h"

#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <unistd.h>

#include "fs_config.h"

char *bufr = "Happy days are here again.  Happy days are here again.1Happy "
"days are here again.2Happy days are here again.3Happy days are here again."
"4Happy days are here again.5Happy days are here again.6Happy days are here "
"again.7Happy days are here again.";

rtems_task Init(
  rtems_task_argument ignored
)
{
  int     fd;
  int     i;
  int     n;
  int     rc;
  int     total_written;
  int     total_read;
  char   *bufr2;
  size_t  len = strlen(bufr);

  puts( "\n\n*** SIMPLE READ/WRITE TEST (" FILESYSTEM ") ***" );

  puts( "Initializing filesystem " FILESYSTEM );
  test_initialize_filesystem();

  printf( "sizeof(buffer) = %d\n", len);
  total_written = 0;

  /*
   *  Create the file
   */
  puts( "Creating " BASE_FOR_TEST "tester" );
  fd = creat(BASE_FOR_TEST "tester", S_IRWXU | S_IRWXG | S_IRWXO);
  rtems_test_assert( fd != -1 );

  /*
   *  Write the file
   */
  printf( "Writing %d bytes to file\n", len * 10 );
  for (i=0; i<10; i++) {
    n = write(fd, bufr, len);
    rtems_test_assert( n != -1 );
    total_written += n;
  }
  printf("Successfully wrote %d\n", total_written);
  rc = close(fd);
  rtems_test_assert( rc == 0 );

  /*
   *  Now read contents back and verify
   */
  total_read = 0;
  bufr2 = (char *)malloc(len+1);
  rtems_test_assert( bufr2 );

  fd = open( BASE_FOR_TEST "tester", O_RDONLY);
  rtems_test_assert( fd != -1 );

  while ((n=read(fd,bufr2,len)) > 0) {
     total_read += n;
     if ( strncmp( bufr, bufr2, len ) ) {
       printf( "mismatch\\n" );
       rtems_test_exit( 0 );
     }
  }
  if ( total_written != total_read ) {
    printf( "Not enough data read back\\n" );
    rtems_test_exit( 0 );
  }
  printf("Successfully read: %d\n", total_read);
  free(bufr2);
  rc = close(fd);
  rtems_test_assert( rc == 0 );

  puts( "Shutting down filesystem " FILESYSTEM );
  test_shutdown_filesystem();

  puts( "*** END OF SIMPLE READ/WRITE TEST (" FILESYSTEM ") ***" );
  rtems_test_exit(0);
}

/* configuration information */

/* NOTICE: the clock driver is explicitly disabled */
#define CONFIGURE_APPLICATION_DOES_NOT_NEED_CLOCK_DRIVER
#define CONFIGURE_APPLICATION_NEEDS_CONSOLE_DRIVER

#define CONFIGURE_RTEMS_INIT_TASKS_TABLE

#define CONFIGURE_MAXIMUM_TASKS 1
#define CONFIGURE_USE_IMFS_AS_BASE_FILESYSTEM
#define CONFIGURE_LIBIO_MAXIMUM_FILE_DESCRIPTORS 4

#define CONFIGURE_INIT

#include <rtems/confdefs.h>

/* end of file */
